<?php
error_reporting(E_ALL);

global $argv;

// optimized version is going to run
$opt = '';
if (isset($argv[7]))
{
    $opt = 'Optimized';
}

/*
$require = 'P:\wamp\www\diplomovka\benchmarkComplex\actions\actions' . $opt . '.php';
define("XMLDBSERVER","localhost:5550");
define("XMLDB","weblog3");
*/

$require = '/home/lichnerova/benchmarkComplex/actions/actions' . $opt . '.php';
define("XMLDBSERVER","localhost");
define("XMLDB","benchmark");

define("XMLDBUSER","www-blog");
define("XMLDBPASS","XXXXXXXXX");

require_once($require);

class BenchmarkComplex 
{
    public $connection;
    public $fileName = '-benchComplex.csv';
    /*
    public $resultFilePath = 'P:/wamp/www/diplomovka/benchmarkComplex/csv/';
    public $xmlFilesPath = 'P:/wamp/www/diplomovka/benchmarkComplex/xml/';
    */
    public $resultFilePath = '/home/lichnerova/benchmarkComplex/csv/';
    public $xmlFilesPath = '/home/lichnerova/benchmarkComplex/xml/';
    
    public $maxID = 0;
    public $maxIDKeyword = 'max(collection("weblog")';
    
    public $loggedUsers = null;
    public $viewedUsers = null;
    
    public $findArray = array(
        '###USER_NICK###',
        '###USER_ID###',
        '###USER_POST_ID###',
        '###USER_POST_COMMENT_ID###',
        '###LOGGED_USER_ID###',
        '###LOGGED_USER_NICK###',
        '###LOGGED_USER_POST_ID###'
    );
    public $replaceArray = array();
    
    public $execActions = array();
    
    public $optimizedVersion = '';
    
    public $userNum = 0;
    
    public function main()
    {
        global $argv, $argc, $actions, $actionsInsert, $actionsInsertLogged, $loggedUserBeforeAction, $loginAction;
        
        ini_set("sedna.verbosity","0");
        
        if ($argc < 7)
            die('You have to put in 7 arguments not ' . $argc);
            
        $this->userNum = $argv[1];
        $usersCount = $argv[2];
        $isUserLogged = $argv[3];
        $isUserInserting = $argv[4];
        $insRatio = $argv[5];
        $endFileName = $argv[6];
        
        // optimized version is going to run
        if (isset($argv[7]))
        {
            $this->optimizedVersion = 'Optimized-';
            $this->maxIDKeyword = 'data(collection("maximumId")';
        }
        
        $this->fileName = $this->optimizedVersion . $usersCount . '-' . $isUserLogged . 
            '-' . $insRatio . '-' . $endFileName . '-' . $this->fileName;
        
        $this->getLoggedUsers();
        $this->getViewedUsers();
        
        $randViewedUsers = $this->userNum*$usersCount % count($this->viewedUsers);
        $randLoggedUsers = $this->userNum*$usersCount % count($this->loggedUsers);
        
        $this->replaceArray = array(
            $this->viewedUsers[$randViewedUsers]['nick'],
            $this->viewedUsers[$randViewedUsers]['ID'],
            $this->viewedUsers[$randViewedUsers]['postID'],
            $this->viewedUsers[$randViewedUsers]['commentID'],
            $this->loggedUsers[$randLoggedUsers]['ID'],
            $this->loggedUsers[$randLoggedUsers]['nick'],
            $this->loggedUsers[$randLoggedUsers]['postID']
        );
        
        echo '--------- User no. ' . $this->userNum . ' started' . "\n"; 
        
        // actions executions
        if ($isUserLogged)
        {
            // user is logged and inserts post/comment
            if ($isUserInserting)
            {
                // log user
                $this->loginUser();
                
                // initialize action execution times
                $this->initializeActions($actions);
                $this->initializeActions($actionsInsert);
                $this->initializeActions($actionsInsertLogged);
                
                // execute actions
                foreach ($actions as $name => $stats)
                {
                    // execute all action statements
                    $this->executeAction($actions,$name,false,true);
                }
                
                $postInsert = ($this->userNum/$insRatio)%($usersCount/$insRatio);
                // insert post
                if ($postInsert < ($usersCount/$insRatio/2))
                {
                    $insAction = ($this->userNum/$insRatio)%2;
                    $this->executeAction($actionsInsertLogged,'userPostsPage',false,true);
                    if ($insAction)
                    {
                        $this->executeAction($actionsInsertLogged,'insertPostPage',false,true);
                        $this->executeAction($actionsInsertLogged,'insertPostAction',true,true);
                    }
                    else
                    {
                        $this->executeAction($actionsInsertLogged,'updatePostPage',false,true);
                        $this->executeAction($actionsInsertLogged,'updatePostAction',true,true);
                    }
                }
                // insert comment
                else
                {
                    $insAction = ($this->userNum/$insRatio)%2;
                    // execute all action statements
                    $this->executeAction($actionsInsert,'insertCommentPage',false,true);
                    if ($insAction)
                        $this->executeAction($actionsInsert,'insertCommentToCommentAction',true,true);
                    else
                        $this->executeAction($actionsInsert,'insertCommentToPostAction',true,true);
                }
            }
            // user is logged and reads only
            else
            {
                // log user
                $this->loginUser();
                
                // initialize action execution times
                $this->initializeActions($actions);
                $this->initializeActions($actionsInsert);
                $this->initializeActions($actionsInsertLogged);
                
                // execute actions
                foreach ($actions as $name => $stats)
                {
                    // execute all action statements
                    $this->executeAction($actions,$name,false,true);
                }
            }
        }
        // user is not logged
        else
        {
            // user is non-logged and inserts comment
            if ($isUserInserting)
            {
                // initialize action execution times
                $this->initializeActions($actions);
                $this->initializeActions($actionsInsert);
                
                // execute actions
                foreach ($actions as $name => $stats)
                {
                    // execute all action statements
                    $this->executeAction($actions,$name);
                }
                
                // execute insert
                $insAction = ($this->userNum/$insRatio)%2;
                $this->executeAction($actionsInsert,'insertCommentPage');
                if ($insAction)
                    $this->executeAction($actionsInsert,'insertCommentToCommentAction',true);
                else
                    $this->executeAction($actionsInsert,'insertCommentToPostAction',true);
            }
            // user is non-logged and reads only
            else
            {
                // initialize action execution times
                $this->initializeActions($actions);
                $this->initializeActions($actionsInsert);
                
                // execute actions
                foreach ($actions as $name => $stats)
                {
                    // execute all action statements
                    $this->executeAction($actions,$name);
                }
            }
        }
        
        $this->writeActionTimes();
        
        echo '--------- User no. ' . $this->userNum . ' ended' . "\n"; 
        
    }
    
    public function getLoggedUsers()
    {
        $filePath = $this->xmlFilesPath . 'loggedUsers.xml';
        $xml = simplexml_load_file($filePath);
        
        if ($xml !== false)
        {
            $this->loggedUsers = array();
            foreach ($xml->user as $user)
            {
                $this->loggedUsers[] = array(
                    'ID' => (string)$user->attributes()->ID,
                    'nick' => (string)$user->nick,
                    'postID' => (string)$user->post->attributes()->ID
                );
            }
        }
        else
        {
            echo "Failed loading XML loggedUsers\n";
            foreach(libxml_get_errors() as $error) {
                echo "\t", $error->message;
            }
        }
    }
    
    public function getViewedUsers()
    {
        $filePath = $this->xmlFilesPath . 'viewedUsers.xml';
        $xml = simplexml_load_file($filePath);
        
        if ($xml !== false)
        {
            $this->viewedUsers = array();
            foreach ($xml->user as $user)
            {
                $this->viewedUsers[] = array(
                    'ID' => (string)$user->attributes()->ID,
                    'nick' => (string)$user->nick,
                    'postID' => (string)$user->post->attributes()->ID,
                    'commentID' => (string)$user->comment->attributes()->ID
                );
            }
        }
        else
        {
            echo "Failed loading XML viewedUsers\n";
            foreach(libxml_get_errors() as $error) {
                echo "\t", $error->message;
            }
        }
    }
    
    public function loginUser()
    {
        global $loginAction;
        
        $this->execActions['login'] = 0;
        
        $this->sednaConnect();
        
        foreach ($loginAction as $key => $stat)
        {
            //change keywords into real values
            $repStat = str_replace($this->findArray,$this->replaceArray,$stat);
            
            $time = $this->sednaExecute($repStat);
            
            $this->execActions['login'] += $time;
            
            $res = sedna_result_array();
            
            //echo '--------------' . "\n" . $repStat . "\n";
        }
        
        $this->sednaClose();
    }
    
    public function initializeActions($arr)
    {
        // initialize action execution times
        foreach($arr as $name => $statSet)
        {
            $this->execActions[$name] = 0;
        }
    }
    
    public function executeAction($act,$name,$insert = false,$logged = false)
    {
        global $loggedUserBeforeAction;
        
        $transStart = 0;
        $count = 0;
        
        //echo '--------------' . "\n" . $name . "\n";
        
        $this->sednaConnect();
        
        // execute statements for logged user
        if ($logged)
        {
            foreach ($loggedUserBeforeAction as $key => $stat)
            {
                //change keywords into real values
                $repStat = str_replace($this->findArray,$this->replaceArray,$stat);
                
                $time = $this->sednaExecute($repStat);
                
                $this->execActions[$name] += $time;
                
                $res = sedna_result_array();
                
                //echo '--------------' . "\n" . $repStat . "\n";
            }
        }
        
        // execute all action statements
        foreach($act[$name] as $key => $stat)
        {
            //change keywords into real values
            $repStat = str_replace($this->findArray,$this->replaceArray,$stat);
            
            if ($insert && $transStart)
                $repStat = str_replace('###MAX_ID###',$this->maxID,$repStat,$count);
            elseif($insert)
                $repStat = str_replace('###MAX_ID###','p' . $this->maxID,$repStat,$count);
            
            // check if transaction start is needed (only in optimized state)
            if ($insert 
                && !$transStart
                && strpos($repStat,$this->maxIDKeyword) !== false
                && strpos($this->maxIDKeyword,'maximumId') !== false)
            {
                $this->startTransaction();
                $transStart = 1;
                //echo '-------------- Transaction start' . "\n";
            }
            
            //echo '--------------' . "\n" . $repStat . "\n";
            
            $time = $this->sednaExecute($repStat);
            
            $this->execActions[$name] += $time;
            
            $res = sedna_result_array();
            
            // check if transaction end is needed
            if ($count && $transStart)
            {    
                $this->endTransaction();
                $transStart = 0;
                //echo '-------------- Transaction end' . "\n";
            }
            
            // get maxID if needed
            if ($insert 
                && strpos($repStat,$this->maxIDKeyword) !== false)
            {
                $res[0]++;
                $this->maxID = $res[0];
            }
        }
        
        $this->sednaClose();
        
        // sleep for some time (5-10 sec)
        $this->afterActionPause();
    }
    
    public function startTransaction()
    {
        // read-only mode off
        $this->sednaReadOnly(false);
        if(sedna_tweak_opt(SE_OPTID_AUTOCOMMIT, false) === NULL)
            die('Could not turn off autocommit mode: ' . sedna_error());
        /* Start a new transaction to load files into collection */
        if(!sedna_transact_begin()) 
            die('Could not start a new transaction: ' . sedna_error());
    }
  
    public function endTransaction()
    {
        /* Commit transaction */
        if(!sedna_transact_commit()) 
            die('Could not commit transaction: ' . sedna_error());
        /* Turn on autocommit mode */
        if(sedna_tweak_opt(SE_OPTID_AUTOCOMMIT, true) === NULL)
            die('Could not turn on autocommit mode: ' . sedna_error());
        // read-only mode on
        $this->sednaReadOnly(true);
    }
    
    public function writeActionTimes()
    {
        $handle = fopen($this->resultFilePath . $this->fileName,'a');
        fputcsv($handle, $this->execActions, ';');
        fclose($handle);
    }
    
    public function sednaConnect()
    {
        // sedna connect
        $this->connection = sedna_connect(XMLDBSERVER,XMLDB,XMLDBUSER,XMLDBPASS);
        if (!$this->connection)
            die('Could not connect: ' . sedna_error());
            
        // read-only mode on
        $this->sednaReadOnly(true);
    }
    
    public function sednaClose()
    {
        sedna_close($this->connection);
    }
    
    public function sednaExecute($stat)
    {
        $readonly = true;
        
        $transactionStat = sedna_transaction_status();

        if (!$transactionStat && preg_match('/^update/i',$stat))
        {
            // read-only mode off
            $this->sednaReadOnly(false);
            $readonly = false;
        }
        
        $start = microtime(true);
        sedna_execute($stat);
        $time = microtime(true) - $start;
        
        // read-only mode on
        if (!$readonly)
            $this->sednaReadOnly(true);
        
        return $time;
    }
    
    public function sednaReadOnly($set)
    {
        if ($this->optimizedVersion)
            if(sedna_tweak_opt(SE_OPTID_READONLY, $set) === NULL)
                    die('Could not turn ON readonly mode: ' . sedna_error());
    }
    
    public function afterActionPause()
    {
        // sleeping interval <5;10)
        $sleep = ($this->userNum % 5) + 5;
        sleep($sleep);
    }
}

$benchmark = new BenchmarkComplex();
$benchmark->main();