<?php
error_reporting(E_ALL);
/*
define("XMLDBSERVER","localhost:5550");
define("XMLDB","weblog3");
*/
define("XMLDBSERVER","localhost");
define("XMLDB","benchmark");

define("XMLDBUSER","www-blog");
define("XMLDBPASS","XXXXXXXXX");

class BenchmarkSimple 
{
    public $connection;
    public $fileName = '-benchmark.csv';
    
    /*
    public $path = 'P:/wamp/www/diplomovka/benchmark/csv/';
    public $queryFilesPath = 'P:/wamp/www/diplomovka/benchmark/queryFiles/';
    public $xmlFilesPath = 'P:/wamp/www/diplomovka/benchmark/xml/';
    */
    
    public $path = '/home/lichnerova/benchmark/csv/';
    public $queryFilesPath = '/home/lichnerova/benchmark/queryFiles/';
    public $xmlFilesPath = '/home/lichnerova/benchmark/xml/';
    
   
    public $iterations = 1000;
    public $maxID = 0;
    
    public $qSet = null;
    
    public $viewedUsers = null;
    public $viewedCount = 0;
    
    public $findArray = array(
        '###USER_ID###',
        '###USER_NICK###',
        '###POST_ID###',
        '###COMMENT_ID###'
    );
    
    public function main()
    {
        global $argv, $argc;
        
        $date = date('j-n-Y_H-i-s');
        
        ini_set("sedna.verbosity","0");
        // sedna connect
        $this->connection = sedna_connect(XMLDBSERVER,XMLDB,XMLDBUSER,XMLDBPASS);
        if (!$this->connection)
            die('Could not connect: ' . sedna_error());
        
        if (!$argv[1])
            die('Index title has to be passed as an argument!');
            
        if (isset($argv[2]))
            $this->iterations = (int)$argv[2];
        
        // get maximum ID        
        $this->getMaxID();
            
        // get addTitle
        $this->fileName = $this->path . $argv[1] . '-' . $this->iterations . '-' . $date . '-' . $this->fileName;
        
        // get queries
        $this->getQueries($argv[1]);
        
        $this->getViewedUsers();
        
        if (!$this->qSet)
            die('Statement file not loaded with this title: ' . $argv[1]);
            
        echo '----- Start benchmark' . "\n";    
        
        // iterate through all queries, execute them and count average duration time   
        foreach ($this->qSet as $key => $aQuery)
        {
            echo 'Start ' . $key . '. query' . "\n";
            
            // execute statement defined number of times - iterations
            for($i = 0;$i < $this->iterations;$i++)
            {
                // replace keywords
                $repKey = $i % $this->viewedCount;
                $newQuery = str_replace($this->findArray,$this->viewedUsers[$repKey],$aQuery['query']);
                
                if (strpos($newQuery,'###MAX_ID###') !== false)
                {
                    $this->maxID++;
                    $newID = (strpos($newQuery,'maximumId') !== false) ? $this->maxID : 'p'.$this->maxID;
                    $newQuery = str_replace('###MAX_ID###',$newID,$newQuery);
                }
                
                $start = microtime(true);
                sedna_execute($newQuery);
                $time = microtime(true) - $start;
                
                $this->qSet[$key]['times'][] = $time;
                $this->qSet[$key]['totalExecTime'] += $time;
                if ($time < $this->qSet[$key]['minExecTime']) 
                    $this->qSet[$key]['minExecTime'] = $time;
                if ($time > $this->qSet[$key]['maxExecTime']) 
                    $this->qSet[$key]['maxExecTime'] = $time;
            }
            
            // compute avgExecTime
            $this->qSet[$key]['avgExecTime'] = $this->qSet[$key]['totalExecTime']/$this->iterations;
            
            // compute standard deviation
            $stDevSum = 0;
            foreach ($this->qSet[$key]['times'] as $statTime)
            {
                $stDevSum += pow($statTime - $this->qSet[$key]['avgExecTime'],2);
            }
            $this->qSet[$key]['standardDeviation'] = sqrt($stDevSum/$this->iterations);
            unset($this->qSet[$key]['times']);
            
            echo 'Done ' . $key . '. query in ' . $this->qSet[$key]['totalExecTime'] . " sec\n";
        }
        
        $this->setMaxID();
        
        // save results to file
        echo 'Save to file' . "\n";
        
        $handle = fopen($this->fileName,'w');
        
        $title = "StatementID;StatementName;TotalExecTime;MinExecTime;MaxExecTime;AvgExecTime;StandardDeviation\r\n";
        
        fwrite($handle,$title);
        
        foreach ($this->qSet as $key => $aQuery)
        {
            // count Time values in miliseconds
            $aQuery['avgExecTime'] = $aQuery['avgExecTime']*1000;
            $aQuery['totalExecTime'] = $aQuery['totalExecTime']*1000;
            $aQuery['minExecTime'] = $aQuery['minExecTime']*1000;
            $aQuery['maxExecTime'] = $aQuery['maxExecTime']*1000;
            $aQuery['standardDeviation'] = $aQuery['standardDeviation']*1000;
            $inputLine = array(
                $key,
                $aQuery['statementName'],
                $aQuery['totalExecTime'],
                $aQuery['minExecTime'],
                $aQuery['maxExecTime'],
                $aQuery['avgExecTime'],
                $aQuery['standardDeviation']
            );
            fputcsv($handle, $inputLine, ';');
        }
        
        fclose($handle);
        
        sedna_close($this->connection);
        
        echo '----- Done' . "\n";
    }
    
    public function getQueries($indexName)
    {
        $filePath = $this->queryFilesPath . $indexName . '.xml';
        $xml = simplexml_load_file($filePath);
        
        if ($xml !== false)
        {
            $this->qSet = array();
            foreach ($xml->query as $query)
            {
                $attr = $query->attributes();
                $id = (string)$attr['id'];
                $name = (string)$attr['name'];
                $this->qSet[$id] = array(
                    'query' => (string)$query,
                    'statementName' => $name,
                    'totalExecTime' => 0,
                    'minExecTime' => 99999,
                    'maxExecTime' => 0,
                    'avgExecTime' => 0,
                    'times' => array(),
                    'standardDeviation' => 0
                );
            }
        }
        else
        {
            echo "Failed loading XML\n";
            foreach(libxml_get_errors() as $error) {
                echo "\t", $error->message;
            }
        }
    }
    
    public function getMaxID()
    {
        sedna_execute('data(collection("maximumId")/maximumId/postComment)');
        $res = sedna_result_array();
        $this->maxID = $res[0];
    }
    
    public function setMaxID()
    {
        sedna_execute('update replace $i in collection("maximumId")/maximumId/postComment with <postComment>'. $this->maxID .'</postComment>');
    }
    
    public function getViewedUsers()
    {
        $filePath = $this->xmlFilesPath . 'viewedUsers.xml';
        $xml = simplexml_load_file($filePath);
        
        if ($xml !== false)
        {
            $this->viewedUsers = array();
            foreach ($xml->user as $user)
            {
                $this->viewedUsers[] = array(
                    'ID' => (string)$user->attributes()->ID,
                    'nick' => (string)$user->nick,
                    'postID' => (string)$user->post->attributes()->ID,
                    'commentID' => (string)$user->comment->attributes()->ID
                );
            }
            $this->viewedCount = count($this->viewedUsers);
        }
        else
        {
            echo "Failed loading XML viewedUsers\n";
            foreach(libxml_get_errors() as $error) {
                echo "\t", $error->message;
            }
        }
    }
}

$benchmark = new BenchmarkSimple();
$benchmark->main();

?>