<?php
    // actions for non-logged users, assoc. array with action names as keys
    $actions = array(
        'homePage' => array(
            0 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[@status="published"][not(@private="yes")][contains("sk",@lang)], 
                $list := subsequence( 
                    for $i in $all 
                    order by ( if ($i/dateTopOut) then xs:integer($i/dateTopOut/@timestamp) else (if ($i/dateTop) then (xs:integer($i/date/@timestamp)+3600*24*720) else xs:integer($i/date/@timestamp)) ) descending 
                    return $i,1,20), 
                $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="20" start="1">{$posts}</newPosts></module>',
            1 => 'for $i in collection("weblog")/user 
                let $lastName:=if ($i/info/lastName!="") then lower-case(translate($i/info/lastName/text(),"áéíóuýčďľĺňôřšťžÁÉÍÓÚÝČĎĽĹŇÔŘŠŤŽ","aeiouycdllnorstzaeiouycdllnorstz")) else $i/info/nick/text(), 
                $realName:=if ($i/info/realName!="") then $i/info/realName/text() else $i/info/nick/text() where count($i/blog/post[contains("sk",@lang)])>0 
                order by $lastName ascending 
                return <user> {$i/info/nick} {$i/info/ranks} {$i/info/email} <realName>{$realName}</realName> <lastName>{$lastName}</lastName> </user>',
            2 => 'subsequence( (
                for $i in collection("weblog")/user/blog/post[@status="published"][contains("sk",@lang)][ranks/reputationScore>5] 
                let $user := $i/ancestor::user 
                order by ( if ($i/ranks) then xs:double($i/ranks/reputationScore) else xs:double(0.0) ) descending 
                return <post>{$i/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$i/title} {$i/subtitle} {$i/ranks} </post>) ,1,10)',
            3 => 'subsequence( (
                for $i in collection("weblog")/user/blog/post[@status="published"][contains("sk",@lang)][@accessCount>50] 
                let $user := $i/ancestor::user 
                order by xs:integer($i/@accessCount) descending 
                return <post>{$i/@ID}{$i/@lang}{$i/@accessCount} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$i/title} {$i/subtitle} </post>) ,1,10)'
        ),
        'homePageTags' => array(
            0 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[@status="published"][not(@private="yes")][contains("en",@lang)][@ID= ("p16358","p13244","p13245","p16371","p16484","p16489","p16881","p16900","p16870","p19644","p19884","p20338")], 
                $list := subsequence( 
                    for $i in $all 
                    order by ( if ($i/dateTopOut) then xs:integer($i/dateTopOut/@timestamp) else (if ($i/dateTop) then (xs:integer($i/date/@timestamp)+3600*24*720) else xs:integer($i/date/@timestamp)) ) descending 
                    return $i,1,20), 
                $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="20" start="1">{$posts}</newPosts></module>',
            1 => 'for $i in collection("weblog")/user 
                let $lastName:=if ($i/info/lastName!="") then lower-case(translate($i/info/lastName/text(),"áéíóuýčďľĺňôřšťžÁÉÍÓÚÝČĎĽĹŇÔŘŠŤŽ","aeiouycdllnorstzaeiouycdllnorstz")) else $i/info/nick/text(), 
                $realName:=if ($i/info/realName!="") then $i/info/realName/text() else $i/info/nick/text() where count($i/blog/post[contains("en",@lang)])>0 
                order by $lastName ascending 
                return <user> {$i/info/nick} {$i/info/ranks} {$i/info/email} <realName>{$realName}</realName> <lastName>{$lastName}</lastName> </user>',
            2 => 'subsequence( (
                for $i in collection("weblog")/user/blog/post[@status="published"][contains("en",@lang)][ranks/reputationScore>5][@ID= ("p16358","p13244","p13245","p16371","p16484","p16489","p16881","p16900","p16870","p19644","p19884","p20338")] 
                let $user := $i/ancestor::user 
                order by ( if ($i/ranks) then xs:double($i/ranks/reputationScore) else xs:double(0.0) ) descending 
                return <post>{$i/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$i/title} {$i/subtitle} {$i/ranks} </post>) ,1,10)',
            3 => 'subsequence( (
                for $i in collection("weblog")/user/blog/post[@status="published"][contains("en",@lang)][@ID= ("p16358","p13244","p13245","p16371","p16484","p16489","p16881","p16900","p16870","p19644","p19884","p20338")][@accessCount>50] 
                let $user := $i/ancestor::user 
                order by xs:integer($i/@accessCount) descending 
                return <post>{$i/@ID}{$i/@lang}{$i/@accessCount} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$i/title} {$i/subtitle} </post>) ,1,10)'
        ),
        'userHomePage' => array(
            0 => 'collection("weblog")/user[info/nick="###USER_NICK###"]/@ID/normalize-space()',
            1 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[@status="published"][contains("sk",@lang)][../../@ID="###USER_ID###"], 
                $list := subsequence( 
                    for $i in $all 
                    order by ( xs:integer($i/date/@timestamp) ) descending 
                    return $i,1,20), 
                $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="20" start="1">{$posts}</newPosts></module>',
            2 => 'let $all := collection("weblog")/user/blog/post[@status="published"][contains("sk",@lang)][../../@ID="###USER_ID###"]//comment, 
                $last := subsequence( 
                    for $i in $all 
                    order by ( xs:integer($i/date/@timestamp) ) ascending 
                    return $i,count($all),1) 
                return <post>{$last/ancestor::post/@*} {$last/ancestor::post/title} {$last/ancestor::post/subtitle} {$last} </post>',
            3 => 'collection("weblog")/user[@ID="###USER_ID###"]/info',
            4 => 'data(collection("weblog")/user[@ID="###USER_ID###"]/blog/title)',
            5 => 'let $bg := collection("weblog")/user[@ID="###USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>'
        ),
        'userHomePageTags' => array(
            0 => 'collection("weblog")/user[info/nick="###USER_NICK###"]/@ID/normalize-space()',
            1 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[@status="published"][contains("sk",@lang)][@ID= ("p18954","p19563","p19588","p10699","p12224","p12372","p12486","p15284","p12489","p12481","p19617","p20327")][../../@ID="###USER_ID###"], 
                $list := subsequence( 
                    for $i in $all 
                    order by ( xs:integer($i/date/@timestamp) ) descending 
                    return $i,1,20), 
                $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="20" start="1">{$posts}</newPosts></module>',
            2 => 'let $all := collection("weblog")/user/blog/post[@status="published"][contains("sk",@lang)][@ID= ("p18954","p19563","p19588","p10699","p12224","p12372","p12486","p15284","p12489","p12481","p19617","p20327")][../../@ID="###USER_ID###"]//comment, 
                $last := subsequence( 
                    for $i in $all 
                    order by ( xs:integer($i/date/@timestamp) ) ascending 
                    return $i,count($all),1) 
                return <post>{$last/ancestor::post/@*} {$last/ancestor::post/title} {$last/ancestor::post/subtitle} {$last} </post>',
            3 => 'collection("weblog")/user[@ID="###USER_ID###"]/info',
            4 => 'data(collection("weblog")/user[@ID="###USER_ID###"]/blog/title)',
            5 => 'let $bg := collection("weblog")/user[@ID="###USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>'
        ),
        'postDetailPage' => array(
            0 => 'collection("weblog")/user[info/nick="###USER_NICK###"]/@ID/normalize-space()',
            1 => 'data(collection("weblog")/user[@ID="###USER_ID###"]/blog/post[@ID="###USER_POST_ID###"]/@accessCount)',
            2 => 'update replace $i in collection("weblog")/user[@ID="###USER_ID###"]/blog/post[@ID="###USER_POST_ID###"]/@accessCount with attribute accessCount {539}',
            3 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[@status="published"][../../@ID="###USER_ID###"][@ID="###USER_POST_ID###"], 
                $list := subsequence( for $i in $all return $i,1,1), 
                $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="1" start="1">{$posts}</newPosts></module>',
            4 => 'for $i in collection("weblog")/user/blog/post[@status="published"][../../@ID="###USER_ID###"][@ID!="###USER_POST_ID###"] 
                order by ( xs:integer($i/date/@timestamp) ) descending 
                return <post> {$i/@status} {$i/@private} {$i/@ID} {$i/title} {$i/date} </post>',
            5 => 'collection("weblog")/user[@ID="###USER_ID###"]/info',
            6 => 'data(collection("weblog")/user[@ID="###USER_ID###"]/blog/title)',
            7 => 'let $bg := collection("weblog")/user[@ID="###USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
    );
    
    // actions for non-logged users, who also insert comment
    $actionsInsert = array(
        'insertCommentPage' => array(
            0 => 'collection("weblog")/user[info/nick="###USER_NICK###"]/@ID/normalize-space()',
            1 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[@status="published"][../../@ID="###USER_ID###"][@ID="###USER_POST_ID###"], 
                $list := subsequence( for $i in $all return $i,1,1), 
                $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="1" start="1">{$posts}</newPosts></module>',
            2 => 'let $bg := collection("weblog")/user[@ID="###USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
        'insertCommentToPostAction' => array(
            0 => 'collection("weblog")/user[info/nick="###USER_NICK###"]/@ID/normalize-space()',
            1 => 'max(collection("weblog")/user/blog//*[name()="post" or name()="comment"]/number(substring-after(@ID,"p")))',
            2 => 'update insert <comment ID="###MAX_ID###"><author guest="true">EviLich</author><content>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. </content> <title>testik</title> <date timestamp="1330724469">2012-03-02T22:41:09</date> </comment>into collection("weblog")/user[@ID="###USER_ID###"]/blog/post[@ID="###USER_POST_ID###"]/comments',
            3 => 'data(collection("weblog")/user[@ID="###USER_ID###"]/blog/post[@ID="###USER_POST_ID###"]/@accessCount)',
            4 => 'update replace $i in collection("weblog")/user[@ID="###USER_ID###"]/blog/post[@ID="###USER_POST_ID###"]/@accessCount with attribute accessCount {539}',
            5 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[@status="published"][../../@ID="###USER_ID###"][@ID="###USER_POST_ID###"], 
                $list := subsequence( for $i in $all return $i,1,1), 
                $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="1" start="1">{$posts}</newPosts></module>',
            6 => 'for $i in collection("weblog")/user/blog/post[@status="published"][../../@ID="###USER_ID###"][@ID!="###USER_POST_ID###"] 
                order by ( xs:integer($i/date/@timestamp) ) descending 
                return <post> {$i/@status} {$i/@private} {$i/@ID} {$i/title} {$i/date} </post>',
            7 => 'collection("weblog")/user[@ID="###USER_ID###"]/info',
            8 => 'data(collection("weblog")/user[@ID="###USER_ID###"]/blog/title)',
            9 => 'let $bg := collection("weblog")/user[@ID="###USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
        'insertCommentToCommentAction' => array(
            0 => 'collection("weblog")/user[info/nick="###USER_NICK###"]/@ID/normalize-space()',
            1 => 'max(collection("weblog")/user/blog//*[name()="post" or name()="comment"]/number(substring-after(@ID,"p")))',
            2 => 'update insert <comment ID="###MAX_ID###"><author guest="true">EviLich</author><content>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. </content> <title>testik</title> <date timestamp="1330724469">2012-03-02T22:41:09</date> </comment>into collection("weblog")/user[@ID="###USER_ID###"]/blog/post[@ID="###USER_POST_ID###"]//comment[@ID="###USER_POST_COMMENT_ID###"]',
            3 => 'data(collection("weblog")/user[@ID="###USER_ID###"]/blog/post[@ID="###USER_POST_ID###"]/@accessCount)',
            4 => 'update replace $i in collection("weblog")/user[@ID="###USER_ID###"]/blog/post[@ID="###USER_POST_ID###"]/@accessCount with attribute accessCount {539}',
            5 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[@status="published"][../../@ID="###USER_ID###"][@ID="###USER_POST_ID###"], 
                $list := subsequence( for $i in $all return $i,1,1), 
                $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="1" start="1">{$posts}</newPosts></module>',
            6 => 'for $i in collection("weblog")/user/blog/post[@status="published"][../../@ID="###USER_ID###"][@ID!="###USER_POST_ID###"] 
                order by ( xs:integer($i/date/@timestamp) ) descending 
                return <post> {$i/@status} {$i/@private} {$i/@ID} {$i/title} {$i/date} </post>',
            7 => 'collection("weblog")/user[@ID="###USER_ID###"]/info',
            8 => 'data(collection("weblog")/user[@ID="###USER_ID###"]/blog/title)',
            9 => 'let $bg := collection("weblog")/user[@ID="###USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
    );
    
    // actions for logged users, who also insert post
    $actionsInsertLogged = array(
        'userPostsPage' => array(
            0 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[contains("sk",@lang)][../../@ID="###LOGGED_USER_ID###"], 
                $list := subsequence( 
                    for $i in $all 
                    order by ( xs:integer($i/date/@timestamp) ) descending 
                    return $i,1,20), $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="20" start="1">{$posts}</newPosts></module>',
            1 => 'let $bg := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
        'insertPostPage' => array(
            0 => 'let $bg := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
        'insertPostAction' => array(
            0 => 'max(collection("weblog")/user/blog//*[name()="post" or name()="comment"]/number(substring-after(@ID,"p")))',
            1 => 'update insert <post ID="###MAX_ID###" accessCount="0" lang="sk" status="published" private="no"> <title>Testik</title> <subtitle></subtitle> <content> ====Lorem ipsum==== dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut **enim** ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. </content> <tags><tag></tag></tags> <date timestamp="1330767230">2012-03-03T10:33:50</date> <comments/> <topics/> </post> into collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog',
            2 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[contains("sk",@lang)][../../@ID="###LOGGED_USER_ID###"], 
                $list := subsequence( 
                    for $i in $all 
                    order by ( xs:integer($i/date/@timestamp) ) descending 
                    return $i,1,20), $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="20" start="1">{$posts}</newPosts></module>',
            3 => 'let $bg := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
        'updatePostPage' => array(
            0 => 'collection("weblog")/user/blog/post[../../@ID="###LOGGED_USER_ID###"][@ID="###LOGGED_USER_POST_ID###"]',
            1 => 'let $bg := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
        'updatePostAction' => array(
            0 => 'update replace $i in collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/post[@ID="###LOGGED_USER_POST_ID###"] with if ($i/@type) then <post ID="###LOGGED_USER_POST_ID###" accessCount="{$i/@accessCount+1}" lang="sk" status="draft" private="no"> {$i/@type} {$i/@submitted} <title>testik</title> <subtitle></subtitle> <content> testik upravey </content> <tags><tag>school</tag></tags> <lastUpdate timestamp="1332628798">2012-03-24T23:39:58</lastUpdate> {$i/date} {$i/comments} {$i/dateTop} {$i/dateTopOut} <topics/> </post> else <post ID="###LOGGED_USER_POST_ID###" accessCount="{$i/@accessCount+1}" lang="sk" status="draft" private="no"> {$i/@type} {$i/@submitted} <title>testik</title> <subtitle></subtitle> <content> testik upravey </content> <tags><tag>school</tag></tags> <lastUpdate timestamp="1332628798">2012-03-24T23:39:58</lastUpdate> {$i/date} {$i/comments} {$i/topics} {$i/dateTop} {$i/dateTopOut} </post>',
            1 => 'declare option se:output "indent=no"; 
                let $all := collection("weblog")/user/blog/post[contains("sk",@lang)][../../@ID="###LOGGED_USER_ID###"], 
                $list := subsequence( 
                    for $i in $all 
                    order by ( xs:integer($i/date/@timestamp) ) descending 
                    return $i,1,20), $last := count($all), 
                $posts:= (for $current in $list 
                    let $user := $current/ancestor::user 
                    return <post>{$current/@*} <user>{$user/@ID}{$user/@type} {$user/info/nick} {$user/info/realName} </user> {$current/*} </post> ) 
                return <module name="Articles"><newPosts last="{$last}" end="20" start="1">{$posts}</newPosts></module>',
            2 => 'let $bg := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/background, 
                $color := collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/blog/colorscheme 
                return <customizations> <blogBackground>{$bg}</blogBackground> <colorScheme>{$color}</colorScheme> </customizations>',
        ),
    );
    
    // statements which need to be executed before each action, if user is logged in
    $loggedUserBeforeAction = array(
        0 => 'collection("weblog")/user[info/nick="###LOGGED_USER_NICK###"]/@ID/normalize-space()',
        1 => 'collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/info',
        2 => 'data(collection("course")/courses/course[@year="2011/2012"]/users/user[@ref="###LOGGED_USER_NICK###"]/@type)',
        3 => 'data(collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/@type)',
    );
    
    // login action
    $loginAction = array(
        0 => 'collection("weblog")/user[info/nick="###LOGGED_USER_NICK###"]/account/password/text()',
        1 => 'collection("weblog")/user[info/nick="###LOGGED_USER_NICK###"]/@ID/normalize-space()',
        2 => 'collection("weblog")/user[@ID="###LOGGED_USER_ID###"]/info'
    );

?>